diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_lib.c openssl-1.0.0q/crypto/pem/pem_lib.c
--- openssl-1.0.0q.orig/crypto/pem/pem_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_lib.c	2017-04-25 16:23:40.563621072 +0200
@@ -56,9 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
@@ -66,7 +69,7 @@
 #include <openssl/x509.h>
 #include <openssl/pem.h>
 #include <openssl/pkcs12.h>
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
 #ifndef OPENSSL_NO_DES
 #include <openssl/des.h>
 #endif
@@ -74,17 +77,21 @@
 #include <openssl/engine.h>
 #endif
 
-const char PEM_version[]="PEM" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char PEM_version[]="PEM" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2007-02-26 haavardm */
+#endif
 
 #define MIN_LENGTH	4
 
+#ifndef OPERA_SMALL_VERSION
 static int load_iv(char **fromp,unsigned char *to, int num);
+#endif
 static int check_pem(const char *nm, const char *name);
 int pem_check_suffix(const char *pem_str, const char *suffix);
 
 int PEM_def_callback(char *buf, int num, int w, void *key)
 	{
-#ifdef OPENSSL_NO_FP_API
+#if defined(OPENSSL_NO_FP_API) || defined(_SSL_USE_OPENSSL_)
 	/* We should not ever call the default callback routine from
 	 * windows. */
 	PEMerr(PEM_F_PEM_DEF_CALLBACK,ERR_R_SHOULD_NOT_HAVE_BEEN_CALLED);
@@ -93,9 +100,9 @@
 	int i,j;
 	const char *prompt;
 	if(key) {
-		i=strlen(key);
+		i=op_strlen(key);
 		i=(i > num)?num:i;
-		memcpy(buf,key,i);
+		op_memcpy(buf,key,i);
 		return(i);
 	}
 
@@ -109,10 +116,10 @@
 		if (i != 0)
 			{
 			PEMerr(PEM_F_PEM_DEF_CALLBACK,PEM_R_PROBLEMS_GETTING_PASSWORD);
-			memset(buf,0,(unsigned int)num);
+			op_memset(buf,0,(unsigned int)num);
 			return(-1);
 			}
-		j=strlen(buf);
+		j=op_strlen(buf);
 		if (j < MIN_LENGTH)
 			{
 			fprintf(stderr,"phrase is too short, needs to be at least %d chars\n",MIN_LENGTH);
@@ -144,14 +151,14 @@
 
 void PEM_dek_info(char *buf, const char *type, int len, char *str)
 	{
-	static const unsigned char map[17]="0123456789ABCDEF";
+	const char *const map="0123456789ABCDEF";
 	long i;
 	int j;
 
 	BUF_strlcat(buf,"DEK-Info: ",PEM_BUFSIZE);
 	BUF_strlcat(buf,type,PEM_BUFSIZE);
 	BUF_strlcat(buf,",",PEM_BUFSIZE);
-	j=strlen(buf);
+	j=op_strlen(buf);
 	if (j + (len * 2) + 1 > PEM_BUFSIZE)
         	return;
 	for (i=0; i<len; i++)
@@ -239,22 +246,22 @@
 
 	/* Permit older strings */
 
-	if(!strcmp(nm,PEM_STRING_X509_OLD) &&
-		!strcmp(name,PEM_STRING_X509)) return 1;
+	if(!op_strcmp(nm,PEM_STRING_X509_OLD) &&
+		!op_strcmp(name,PEM_STRING_X509)) return 1;
 
-	if(!strcmp(nm,PEM_STRING_X509_REQ_OLD) &&
-		!strcmp(name,PEM_STRING_X509_REQ)) return 1;
+	if(!op_strcmp(nm,PEM_STRING_X509_REQ_OLD) &&
+		!op_strcmp(name,PEM_STRING_X509_REQ)) return 1;
 
 	/* Allow normal certs to be read as trusted certs */
-	if(!strcmp(nm,PEM_STRING_X509) &&
-		!strcmp(name,PEM_STRING_X509_TRUSTED)) return 1;
+	if(!op_strcmp(nm,PEM_STRING_X509) &&
+		!op_strcmp(name,PEM_STRING_X509_TRUSTED)) return 1;
 
-	if(!strcmp(nm,PEM_STRING_X509_OLD) &&
-		!strcmp(name,PEM_STRING_X509_TRUSTED)) return 1;
+	if(!op_strcmp(nm,PEM_STRING_X509_OLD) &&
+		!op_strcmp(name,PEM_STRING_X509_TRUSTED)) return 1;
 
 	/* Some CAs use PKCS#7 with CERTIFICATE headers */
-	if(!strcmp(nm, PEM_STRING_X509) &&
-		!strcmp(name, PEM_STRING_PKCS7)) return 1;
+	if(!op_strcmp(nm, PEM_STRING_X509) &&
+		!op_strcmp(name, PEM_STRING_PKCS7)) return 1;
 
 	if(!strcmp(nm, PEM_STRING_PKCS7_SIGNED) &&
 		!strcmp(name, PEM_STRING_PKCS7)) return 1;
@@ -284,7 +291,9 @@
 		if (!PEM_read_bio(bp,&nm,&header,&data,&len)) {
 			if(ERR_GET_REASON(ERR_peek_error()) ==
 				PEM_R_NO_START_LINE)
+#ifndef OPERA_SMALL_VERSION
 				ERR_add_error_data(2, "Expecting: ", name);
+#endif
 			return 0;
 		}
 		if(check_pem(nm, name)) break;
@@ -335,12 +344,17 @@
 		       int klen, pem_password_cb *callback, void *u)
 	{
 	EVP_CIPHER_CTX ctx;
+#ifdef OPERA_SMALL_VERSION
+	// Fix for warning: unused variable ‘j’.
+	int dsize=0,i,  ret=0;
+#else
 	int dsize=0,i,j,ret=0;
+#endif
 	unsigned char *p,*data=NULL;
 	const char *objstr=NULL;
-	char buf[PEM_BUFSIZE];
-	unsigned char key[EVP_MAX_KEY_LENGTH];
-	unsigned char iv[EVP_MAX_IV_LENGTH];
+	char buf[PEM_BUFSIZE]; /* ARRAY OK UNUSED 2007-04-23 yngve */
+	unsigned char key[EVP_MAX_KEY_LENGTH]; /* ARRAY OK UNUSED 2007-04-23 yngve */
+	unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2007-04-23 yngve */
 	
 	if (enc != NULL)
 		{
@@ -371,6 +385,10 @@
 
 	if (enc != NULL)
 		{
+#ifdef OPERA_SMALL_VERSION
+		// Encrypted PEMs are not supported in OPERA_SMALL_VERSION - error exit
+		goto err;
+#else
 		if (kstr == NULL)
 			{
 			if (callback == NULL)
@@ -398,12 +416,12 @@
 
 		if (kstr == (unsigned char *)buf) OPENSSL_cleanse(buf,PEM_BUFSIZE);
 
-		OPENSSL_assert(strlen(objstr)+23+2*enc->iv_len+13 <= sizeof buf);
+		OPENSSL_assert(op_strlen(objstr)+23+2*enc->iv_len+13 <= sizeof buf);
 
 		buf[0]='\0';
 		PEM_proc_type(buf,PEM_TYPE_ENCRYPTED);
 		PEM_dek_info(buf,objstr,enc->iv_len,(char *)iv);
-		/* k=strlen(buf); */
+		/* k=op_strlen(buf); */
 
 		EVP_CIPHER_CTX_init(&ctx);
 		EVP_EncryptInit_ex(&ctx,enc,NULL,key,iv);
@@ -412,6 +430,7 @@
 		EVP_CIPHER_CTX_cleanup(&ctx);
 		i+=j;
 		ret=1;
+#endif // OPERA_SMALL_VERSION
 		}
 	else
 		{
@@ -436,11 +455,17 @@
 int PEM_do_header(EVP_CIPHER_INFO *cipher, unsigned char *data, long *plen,
 	     pem_password_cb *callback,void *u)
 	{
+#ifdef OPERA_SMALL_VERSION
+	if (cipher->cipher == NULL) return(1);
+
+	// Encrypted PEMs are not supported in OPERA_SMALL_VERSION - error exit.
+	return 0;
+#else
 	int i,j,o,klen;
 	long len;
 	EVP_CIPHER_CTX ctx;
-	unsigned char key[EVP_MAX_KEY_LENGTH];
-	char buf[PEM_BUFSIZE];
+	unsigned char key[EVP_MAX_KEY_LENGTH]; /* ARRAY OK UNUSED 2007-04-23 yngve */
+	char buf[PEM_BUFSIZE]; /* ARRAY OK UNUSED 2007-04-23 yngve */
 
 	len= *plen;
 
@@ -478,10 +503,19 @@
 		}
 	*plen=j;
 	return(1);
+#endif // OPERA_SMALL_VERSION
 	}
 
 int PEM_get_EVP_CIPHER_INFO(char *header, EVP_CIPHER_INFO *cipher)
 	{
+#ifdef OPERA_SMALL_VERSION
+	cipher->cipher=NULL;
+	if ((header == NULL) || (*header == '\0') || (*header == '\n'))
+		return(1);
+
+	// Non-empty header is not supported in OPERA_SMALL_VERSION - error exit.
+	return 0;
+#else
 	const EVP_CIPHER *enc=NULL;
 	char *p,c;
 	char **header_pp = &header;
@@ -489,19 +523,19 @@
 	cipher->cipher=NULL;
 	if ((header == NULL) || (*header == '\0') || (*header == '\n'))
 		return(1);
-	if (strncmp(header,"Proc-Type: ",11) != 0)
+	if (op_strncmp(header,"Proc-Type: ",11) != 0)
 		{ PEMerr(PEM_F_PEM_GET_EVP_CIPHER_INFO,PEM_R_NOT_PROC_TYPE); return(0); }
 	header+=11;
 	if (*header != '4') return(0); header++;
 	if (*header != ',') return(0); header++;
-	if (strncmp(header,"ENCRYPTED",9) != 0)
+	if (op_strncmp(header,"ENCRYPTED",9) != 0)
 		{ PEMerr(PEM_F_PEM_GET_EVP_CIPHER_INFO,PEM_R_NOT_ENCRYPTED); return(0); }
 	for (; (*header != '\n') && (*header != '\0'); header++)
 		;
 	if (*header == '\0')
 		{ PEMerr(PEM_F_PEM_GET_EVP_CIPHER_INFO,PEM_R_SHORT_HEADER); return(0); }
 	header++;
-	if (strncmp(header,"DEK-Info: ",10) != 0)
+	if (op_strncmp(header,"DEK-Info: ",10) != 0)
 		{ PEMerr(PEM_F_PEM_GET_EVP_CIPHER_INFO,PEM_R_NOT_DEK_INFO); return(0); }
 	header+=10;
 
@@ -514,8 +548,8 @@
 			((c >= '0') && (c <= '9'))))
 			break;
 #else
-		if (!(	isupper(c) || (c == '-') ||
-			isdigit(c)))
+		if (!(	op_isupper(c) || (c == '-') ||
+			op_isdigit(c)))
 			break;
 #endif
 		header++;
@@ -534,8 +568,10 @@
 		return(0);
 
 	return(1);
+#endif // OPERA_SMALL_VERSION
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static int load_iv(char **fromp, unsigned char *to, int num)
 	{
 	int v,i;
@@ -564,6 +600,7 @@
 	*fromp=from;
 	return(1);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 #ifndef OPENSSL_NO_FP_API
 int PEM_write(FILE *fp, char *name, char *header, unsigned char *data,
@@ -593,14 +630,14 @@
 	int reason=ERR_R_BUF_LIB;
 	
 	EVP_EncodeInit(&ctx);
-	nlen=strlen(name);
+	nlen=op_strlen(name);
 
 	if (	(BIO_write(bp,"-----BEGIN ",11) != 11) ||
 		(BIO_write(bp,name,nlen) != nlen) ||
 		(BIO_write(bp,"-----\n",6) != 6))
 		goto err;
 		
-	i=strlen(header);
+	i=op_strlen(header);
 	if (i > 0)
 		{
 		if (	(BIO_write(bp,header,i) != i) ||
@@ -608,7 +645,7 @@
 			goto err;
 		}
 
-	buf = OPENSSL_malloc(PEM_BUFSIZE*8);
+	buf = (unsigned char*)OPENSSL_malloc(PEM_BUFSIZE*8);
 	if (buf == NULL)
 		{
 		reason=ERR_R_MALLOC_FAILURE;
@@ -669,7 +706,7 @@
 	{
 	EVP_ENCODE_CTX ctx;
 	int end=0,i,k,bl=0,hl=0,nohead=0;
-	char buf[256];
+	char buf[256]; /* ARRAY OK UNUSED 2007-04-23 yngve */
 	BUF_MEM *nameB;
 	BUF_MEM *headerB;
 	BUF_MEM *dataB,*tmpB;
@@ -700,18 +737,18 @@
 		while ((i >= 0) && (buf[i] <= ' ')) i--;
 		buf[++i]='\n'; buf[++i]='\0';
 
-		if (strncmp(buf,"-----BEGIN ",11) == 0)
+		if (op_strncmp(buf,"-----BEGIN ",11) == 0)
 			{
-			i=strlen(&(buf[11]));
+			i=op_strlen(&(buf[11]));
 
-			if (strncmp(&(buf[11+i-6]),"-----\n",6) != 0)
+			if (op_strncmp(&(buf[11+i-6]),"-----\n",6) != 0)
 				continue;
 			if (!BUF_MEM_grow(nameB,i+9))
 				{
 				PEMerr(PEM_F_PEM_READ_BIO,ERR_R_MALLOC_FAILURE);
 				goto err;
 				}
-			memcpy(nameB->data,&(buf[11]),i-6);
+			op_memcpy(nameB->data,&(buf[11]),i-6);
 			nameB->data[i-6]='\0';
 			break;
 			}
@@ -731,12 +768,12 @@
 		if (buf[0] == '\n') break;
 		if (!BUF_MEM_grow(headerB,hl+i+9))
 			{ PEMerr(PEM_F_PEM_READ_BIO,ERR_R_MALLOC_FAILURE); goto err; }
-		if (strncmp(buf,"-----END ",9) == 0)
+		if (op_strncmp(buf,"-----END ",9) == 0)
 			{
 			nohead=1;
 			break;
 			}
-		memcpy(&(headerB->data[hl]),buf,i);
+		op_memcpy(&(headerB->data[hl]),buf,i);
 		headerB->data[hl+i]='\0';
 		hl+=i;
 		}
@@ -756,7 +793,7 @@
 			buf[++i]='\n'; buf[++i]='\0';
 
 			if (i != 65) end=1;
-			if (strncmp(buf,"-----END ",9) == 0)
+			if (op_strncmp(buf,"-----END ",9) == 0)
 				break;
 			if (i > 65) break;
 			if (!BUF_MEM_grow_clean(dataB,i+bl+9))
@@ -764,7 +801,7 @@
 				PEMerr(PEM_F_PEM_READ_BIO,ERR_R_MALLOC_FAILURE);
 				goto err;
 				}
-			memcpy(&(dataB->data[bl]),buf,i);
+			op_memcpy(&(dataB->data[bl]),buf,i);
 			dataB->data[bl+i]='\0';
 			bl+=i;
 			if (end)
@@ -787,10 +824,10 @@
 		dataB=tmpB;
 		bl=hl;
 		}
-	i=strlen(nameB->data);
-	if (	(strncmp(buf,"-----END ",9) != 0) ||
-		(strncmp(nameB->data,&(buf[9]),i) != 0) ||
-		(strncmp(&(buf[9+i]),"-----\n",6) != 0))
+	i=op_strlen(nameB->data);
+	if (	(op_strncmp(buf,"-----END ",9) != 0) ||
+		(op_strncmp(nameB->data,&(buf[9]),i) != 0) ||
+		(op_strncmp(&(buf[9+i]),"-----\n",6) != 0))
 		{
 		PEMerr(PEM_F_PEM_READ_BIO,PEM_R_BAD_END_LINE);
 		goto err;
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_oth.c openssl-1.0.0q/crypto/pem/pem_oth.c
--- openssl-1.0.0q.orig/crypto/pem/pem_oth.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_oth.c	2017-04-25 16:23:40.563621072 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
@@ -78,7 +80,7 @@
 	if (!PEM_bytes_read_bio(&data, &len, NULL, name, bp, cb, u))
 		return NULL;
 	p = data;
-	ret=d2i(x,&p,len);
+	ret=(char*)d2i(x,&p,len);
 	if (ret == NULL)
 		PEMerr(PEM_F_PEM_ASN1_READ_BIO,ERR_R_ASN1_LIB);
 	OPENSSL_free(data);
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_pk8.c openssl-1.0.0q/crypto/pem/pem_pk8.c
--- openssl-1.0.0q.orig/crypto/pem/pem_pk8.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_pk8.c	2017-04-25 16:23:40.564620640 +0200
@@ -56,7 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_pkey.c openssl-1.0.0q/crypto/pem/pem_pkey.c
--- openssl-1.0.0q.orig/crypto/pem/pem_pkey.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_pkey.c	2017-04-25 16:23:40.565620488 +0200
@@ -56,7 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_seal.c openssl-1.0.0q/crypto/pem/pem_seal.c
--- openssl-1.0.0q.orig/crypto/pem/pem_seal.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_seal.c	2017-04-25 16:23:40.566620615 +0200
@@ -58,7 +58,9 @@
 
 #include <openssl/opensslconf.h>	/* for OPENSSL_NO_RSA */
 #ifndef OPENSSL_NO_RSA
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/rand.h>
@@ -108,7 +110,7 @@
 		j=EVP_EncodeBlock((unsigned char *)s,ek[i],
 			RSA_size(pubk[i]->pkey.rsa));
 		ekl[i]=j;
-		memcpy(ek[i],s,j+1);
+		op_memcpy(ek[i],s,j+1);
 		}
 
 	ret=npubk;
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_sign.c openssl-1.0.0q/crypto/pem/pem_sign.c
--- openssl-1.0.0q.orig/crypto/pem/pem_sign.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_sign.c	2017-04-25 16:23:40.567620742 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #include <openssl/evp.h>
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_x509.c openssl-1.0.0q/crypto/pem/pem_x509.c
--- openssl-1.0.0q.orig/crypto/pem/pem_x509.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_x509.c	2017-04-25 16:23:40.567620742 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_xaux.c openssl-1.0.0q/crypto/pem/pem_xaux.c
--- openssl-1.0.0q.orig/crypto/pem/pem_xaux.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_xaux.c	2017-04-25 16:23:40.568620590 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
@@ -65,4 +68,6 @@
 #include <openssl/pem.h>
 
 IMPLEMENT_PEM_rw(X509_AUX, X509, PEM_STRING_X509_TRUSTED, X509_AUX)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_PEM_rw(X509_CERT_PAIR, X509_CERT_PAIR, PEM_STRING_X509_PAIR, X509_CERT_PAIR)
+#endif /* !OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/perlasm/.gitignore openssl-1.0.0q/crypto/perlasm/.gitignore
--- openssl-1.0.0q.orig/crypto/perlasm/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/perlasm/.gitignore	2017-04-25 16:23:40.569621275 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/.gitignore openssl-1.0.0q/crypto/pkcs12/.gitignore
--- openssl-1.0.0q.orig/crypto/pkcs12/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/.gitignore	2017-04-25 16:23:40.569621275 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_add.c openssl-1.0.0q/crypto/pkcs12/p12_add.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_add.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_add.c	2017-04-25 16:23:40.577621734 +0200
@@ -56,9 +56,14 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Pack an object into an OCTET STRING and turn into a safebag */
 
@@ -160,7 +165,7 @@
 		PKCS12err(PKCS12_F_PKCS12_UNPACK_P7DATA,PKCS12_R_CONTENT_TYPE_NOT_DATA);
 		return NULL;
 		}
-	return ASN1_item_unpack(p7->d.data, ASN1_ITEM_rptr(PKCS12_SAFEBAGS));
+	return (STACK_OF(PKCS12_SAFEBAG) *) ASN1_item_unpack(p7->d.data, ASN1_ITEM_rptr(PKCS12_SAFEBAGS));
 }
 
 /* Turn a stack of SAFEBAGS into a PKCS#7 encrypted data ContentInfo */
@@ -209,7 +214,7 @@
 STACK_OF(PKCS12_SAFEBAG) *PKCS12_unpack_p7encdata(PKCS7 *p7, const char *pass, int passlen)
 {
 	if(!PKCS7_type_is_encrypted(p7)) return NULL;
-	return PKCS12_item_decrypt_d2i(p7->d.encrypted->enc_data->algorithm,
+	return (STACK_OF(PKCS12_SAFEBAG) *) PKCS12_item_decrypt_d2i(p7->d.encrypted->enc_data->algorithm,
 			           ASN1_ITEM_rptr(PKCS12_SAFEBAGS),
 				   pass, passlen,
 			           p7->d.encrypted->enc_data->enc_data, 1);
@@ -236,5 +241,7 @@
 		PKCS12err(PKCS12_F_PKCS12_UNPACK_AUTHSAFES,PKCS12_R_CONTENT_TYPE_NOT_DATA);
 		return NULL;
 		}
-	return ASN1_item_unpack(p12->authsafes->d.data, ASN1_ITEM_rptr(PKCS12_AUTHSAFES));
+	return (STACK_OF(PKCS7) *) ASN1_item_unpack(p12->authsafes->d.data, ASN1_ITEM_rptr(PKCS12_AUTHSAFES));
 }
+
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_asn.c openssl-1.0.0q/crypto/pkcs12/p12_asn.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_asn.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_asn.c	2017-04-25 16:23:40.578620464 +0200
@@ -56,70 +56,79 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/pkcs12.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* PKCS#12 ASN1 module */
 
-ASN1_SEQUENCE(PKCS12) = {
-	ASN1_SIMPLE(PKCS12, version, ASN1_INTEGER),
-	ASN1_SIMPLE(PKCS12, authsafes, PKCS7),
+ASN1_SEQUENCE(PKCS12)
+	ASN1_SIMPLE(PKCS12, version, ASN1_INTEGER)
+	ASN1_SIMPLE(PKCS12, authsafes, PKCS7)
 	ASN1_OPT(PKCS12, mac, PKCS12_MAC_DATA)
-} ASN1_SEQUENCE_END(PKCS12)
+ASN1_SEQUENCE_END(PKCS12)
 
 IMPLEMENT_ASN1_FUNCTIONS(PKCS12)
 
-ASN1_SEQUENCE(PKCS12_MAC_DATA) = {
-	ASN1_SIMPLE(PKCS12_MAC_DATA, dinfo, X509_SIG),
-	ASN1_SIMPLE(PKCS12_MAC_DATA, salt, ASN1_OCTET_STRING),
+ASN1_SEQUENCE(PKCS12_MAC_DATA)
+	ASN1_SIMPLE(PKCS12_MAC_DATA, dinfo, X509_SIG)
+	ASN1_SIMPLE(PKCS12_MAC_DATA, salt, ASN1_OCTET_STRING)
 	ASN1_OPT(PKCS12_MAC_DATA, iter, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(PKCS12_MAC_DATA)
+ASN1_SEQUENCE_END(PKCS12_MAC_DATA)
 
-IMPLEMENT_ASN1_FUNCTIONS(PKCS12_MAC_DATA)
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS12_MAC_DATA)
 
-ASN1_ADB_TEMPLATE(bag_default) = ASN1_EXP(PKCS12_BAGS, value.other, ASN1_ANY, 0);
-
-ASN1_ADB(PKCS12_BAGS) = {
-	ADB_ENTRY(NID_x509Certificate, ASN1_EXP(PKCS12_BAGS, value.x509cert, ASN1_OCTET_STRING, 0)),
-	ADB_ENTRY(NID_x509Crl, ASN1_EXP(PKCS12_BAGS, value.x509crl, ASN1_OCTET_STRING, 0)),
-	ADB_ENTRY(NID_sdsiCertificate, ASN1_EXP(PKCS12_BAGS, value.sdsicert, ASN1_IA5STRING, 0)),
-} ASN1_ADB_END(PKCS12_BAGS, 0, type, 0, &bag_default_tt, NULL);
-
-ASN1_SEQUENCE(PKCS12_BAGS) = {
-	ASN1_SIMPLE(PKCS12_BAGS, type, ASN1_OBJECT),
-	ASN1_ADB_OBJECT(PKCS12_BAGS),
-} ASN1_SEQUENCE_END(PKCS12_BAGS)
-
-IMPLEMENT_ASN1_FUNCTIONS(PKCS12_BAGS)
-
-ASN1_ADB_TEMPLATE(safebag_default) = ASN1_EXP(PKCS12_SAFEBAG, value.other, ASN1_ANY, 0);
-
-ASN1_ADB(PKCS12_SAFEBAG) = {
-	ADB_ENTRY(NID_keyBag, ASN1_EXP(PKCS12_SAFEBAG, value.keybag, PKCS8_PRIV_KEY_INFO, 0)),
-	ADB_ENTRY(NID_pkcs8ShroudedKeyBag, ASN1_EXP(PKCS12_SAFEBAG, value.shkeybag, X509_SIG, 0)),
-	ADB_ENTRY(NID_safeContentsBag, ASN1_EXP_SET_OF(PKCS12_SAFEBAG, value.safes, PKCS12_SAFEBAG, 0)),
-	ADB_ENTRY(NID_certBag, ASN1_EXP(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0)),
-	ADB_ENTRY(NID_crlBag, ASN1_EXP(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0)),
-	ADB_ENTRY(NID_secretBag, ASN1_EXP(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0))
-} ASN1_ADB_END(PKCS12_SAFEBAG, 0, type, 0, &safebag_default_tt, NULL);
-
-ASN1_SEQUENCE(PKCS12_SAFEBAG) = {
-	ASN1_SIMPLE(PKCS12_SAFEBAG, type, ASN1_OBJECT),
-	ASN1_ADB_OBJECT(PKCS12_SAFEBAG),
+ASN1_ADB_TEMPLATE(bag_default)
+	ASN1_EXP1(PKCS12_BAGS, value.other, ASN1_ANY, 0)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_SEQ(PKCS12_BAGS)
+	ADB_ENTRY(NID_x509Certificate, ASN1_EXP2(PKCS12_BAGS, value.x509cert, ASN1_OCTET_STRING, 0))
+	ADB_ENTRY(NID_x509Crl, ASN1_EXP2(PKCS12_BAGS, value.x509crl, ASN1_OCTET_STRING, 0))
+	ADB_ENTRY(NID_sdsiCertificate, ASN1_EXP2(PKCS12_BAGS, value.sdsicert, ASN1_IA5STRING, 0))
+ASN1_ADB_END(PKCS12_BAGS, 0, type, 0, bag_default_tt, NULL)
+
+ASN1_SEQUENCE(PKCS12_BAGS)
+	ASN1_SIMPLE(PKCS12_BAGS, type, ASN1_OBJECT)
+	ASN1_ADB_OBJECT(PKCS12_BAGS)
+ASN1_SEQUENCE_END(PKCS12_BAGS)
+
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS12_BAGS)
+
+ASN1_ADB_TEMPLATE(safebag_default)
+	ASN1_EXP1(PKCS12_SAFEBAG, value.other, ASN1_ANY, 0)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_SEQ(PKCS12_SAFEBAG)
+	ADB_ENTRY(NID_keyBag, ASN1_EXP2(PKCS12_SAFEBAG, value.keybag, PKCS8_PRIV_KEY_INFO, 0))
+	ADB_ENTRY(NID_pkcs8ShroudedKeyBag, ASN1_EXP2(PKCS12_SAFEBAG, value.shkeybag, X509_SIG, 0))
+	ADB_ENTRY(NID_safeContentsBag, ASN1_EXP_SET_OF2(PKCS12_SAFEBAG, value.safes, PKCS12_SAFEBAG, 0))
+	ADB_ENTRY(NID_certBag, ASN1_EXP2(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0))
+	ADB_ENTRY(NID_crlBag, ASN1_EXP2(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0))
+	ADB_ENTRY(NID_secretBag, ASN1_EXP2(PKCS12_SAFEBAG, value.bag, PKCS12_BAGS, 0))
+ASN1_ADB_END(PKCS12_SAFEBAG, 0, type, 0, safebag_default_tt, NULL)
+
+ASN1_SEQUENCE(PKCS12_SAFEBAG)
+	ASN1_SIMPLE(PKCS12_SAFEBAG, type, ASN1_OBJECT)
+	ASN1_ADB_OBJECT(PKCS12_SAFEBAG)
 	ASN1_SET_OF_OPT(PKCS12_SAFEBAG, attrib, X509_ATTRIBUTE)
-} ASN1_SEQUENCE_END(PKCS12_SAFEBAG)
+ASN1_SEQUENCE_END(PKCS12_SAFEBAG)
 
-IMPLEMENT_ASN1_FUNCTIONS(PKCS12_SAFEBAG)
+IMPLEMENT_ASN1_FUNCTIONS3(PKCS12_SAFEBAG)
 
 /* SEQUENCE OF SafeBag */
-ASN1_ITEM_TEMPLATE(PKCS12_SAFEBAGS) = 
+ASN1_ITEM_TEMPLATE(PKCS12_SAFEBAGS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, PKCS12_SAFEBAGS, PKCS12_SAFEBAG)
 ASN1_ITEM_TEMPLATE_END(PKCS12_SAFEBAGS)
 
 /* Authsafes: SEQUENCE OF PKCS7 */
-ASN1_ITEM_TEMPLATE(PKCS12_AUTHSAFES) = 
+ASN1_ITEM_TEMPLATE(PKCS12_AUTHSAFES)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, PKCS12_AUTHSAFES, PKCS7)
 ASN1_ITEM_TEMPLATE_END(PKCS12_AUTHSAFES)
 
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_attr.c openssl-1.0.0q/crypto/pkcs12/p12_attr.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_attr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_attr.c	2017-04-25 16:23:40.578620464 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 /* Add a local keyid to a safebag */
@@ -74,6 +77,7 @@
 
 /* Add key usage to PKCS#8 structure */
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS8_add_keyusage(PKCS8_PRIV_KEY_INFO *p8, int usage)
 {
 	unsigned char us_val;
@@ -84,6 +88,7 @@
 	else
 		return 0;
 }
+#endif
 
 /* Add a friendlyname to a safebag */
 
@@ -98,6 +103,7 @@
 }
 
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS12_add_friendlyname_uni(PKCS12_SAFEBAG *bag,
 				 const unsigned char *name, int namelen)
 {
@@ -117,6 +123,7 @@
 	else
 		return 0;
 }
+#endif
 
 ASN1_TYPE *PKCS12_get_attr_gen(STACK_OF(X509_ATTRIBUTE) *attrs, int attr_nid)
 {
@@ -134,6 +141,7 @@
 	return NULL;
 }
 
+#ifndef OPERA_SMALL_VERSION
 char *PKCS12_get_friendlyname(PKCS12_SAFEBAG *bag)
 {
 	ASN1_TYPE *atype;
@@ -142,4 +150,6 @@
 	return OPENSSL_uni2asc(atype->value.bmpstring->data,
 				 atype->value.bmpstring->length);
 }
+#endif
 
+#endif  // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_crpt.c openssl-1.0.0q/crypto/pkcs12/p12_crpt.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_crpt.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_crpt.c	2017-04-25 16:23:40.579620870 +0200
@@ -56,8 +56,13 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 /* PKCS#12 PBE algorithms now in static table */
@@ -73,7 +78,7 @@
 	int saltlen, iter, ret;
 	unsigned char *salt;
 	const unsigned char *pbuf;
-	unsigned char key[EVP_MAX_KEY_LENGTH], iv[EVP_MAX_IV_LENGTH];
+	unsigned char key[EVP_MAX_KEY_LENGTH], iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK 2004-02-18 yngve */
 
 	/* Extract useful info from parameter */
 	if (param == NULL || param->type != V_ASN1_SEQUENCE ||
@@ -110,3 +115,5 @@
 	OPENSSL_cleanse(iv, EVP_MAX_IV_LENGTH);
 	return ret;
 }
+
+#endif //LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_crt.c openssl-1.0.0q/crypto/pkcs12/p12_crt.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_crt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_crt.c	2017-04-25 16:23:40.581620286 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 
@@ -85,7 +88,7 @@
 	STACK_OF(PKCS12_SAFEBAG) *bags = NULL;
 	PKCS12_SAFEBAG *bag = NULL;
 	int i;
-	unsigned char keyid[EVP_MAX_MD_SIZE];
+	unsigned char keyid[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	unsigned int keyidlen = 0;
 
 	/* Set defaults */
@@ -239,8 +242,10 @@
 	/* Make a PKCS#8 structure */
 	if(!(p8 = EVP_PKEY2PKCS8(key)))
 		goto err;
+#ifndef OPERA_SMALL_VERSION
 	if(key_usage && !PKCS8_add_keyusage(p8, key_usage))
 		goto err;
+#endif
 	if (nid_key != -1)
 		{
 		bag = PKCS12_MAKE_SHKEYBAG(nid_key, pass, -1, NULL, 0, iter, p8);
@@ -365,3 +370,4 @@
 	return p12;
 
 	}
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_decr.c openssl-1.0.0q/crypto/pkcs12/p12_decr.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_decr.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_decr.c	2017-04-25 16:23:40.582621531 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 /* Define this to dump decrypted output to files called DERnnn */
@@ -84,7 +87,7 @@
 		return NULL;
 	}
 
-	if(!(out = OPENSSL_malloc(inlen + EVP_CIPHER_CTX_block_size(&ctx)))) {
+	if(!(out = (unsigned char *) OPENSSL_malloc(inlen + EVP_CIPHER_CTX_block_size(&ctx)))) {
 		PKCS12err(PKCS12_F_PKCS12_PBE_CRYPT,ERR_R_MALLOC_FAILURE);
 		goto err;
 	}
@@ -128,9 +131,9 @@
 	{
 		FILE *op;
 
-		char fname[30];
+		char fname[30]; /* ARRAY OK 2007-04-24 yngve DEBUG */
 		static int fnm = 1;
-		sprintf(fname, "DER%d", fnm++);
+		op_sprintf(fname, "DER%d", fnm++);
 		op = fopen(fname, "wb");
 		fwrite (p, 1, outlen, op);
 		fclose(op);
@@ -158,15 +161,17 @@
 		PKCS12err(PKCS12_F_PKCS12_ITEM_I2D_ENCRYPT,ERR_R_MALLOC_FAILURE);
 		return NULL;
 	}
-	inlen = ASN1_item_i2d(obj, &in, it);
+	inlen = ASN1_item_i2d((ASN1_VALUE *) obj, &in, it);
 	if (!in) {
 		PKCS12err(PKCS12_F_PKCS12_ITEM_I2D_ENCRYPT,PKCS12_R_ENCODE_ERROR);
+		M_ASN1_OCTET_STRING_free(oct);
 		return NULL;
 	}
 	if (!PKCS12_pbe_crypt(algor, pass, passlen, in, inlen, &oct->data,
 				 &oct->length, 1)) {
 		PKCS12err(PKCS12_F_PKCS12_ITEM_I2D_ENCRYPT,PKCS12_R_ENCRYPT_ERROR);
 		OPENSSL_free(in);
+		M_ASN1_OCTET_STRING_free(oct);
 		return NULL;
 	}
 	if (zbuf) OPENSSL_cleanse(in, inlen);
@@ -175,3 +180,5 @@
 }
 
 IMPLEMENT_PKCS12_STACK_OF(PKCS7)
+
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_init.c openssl-1.0.0q/crypto/pkcs12/p12_init.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_init.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_init.c	2017-04-25 16:23:40.583621658 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 /* Initialise a PKCS12 structure to take data */
@@ -90,3 +93,5 @@
 	if (pkcs12 != NULL) PKCS12_free(pkcs12);
 	return NULL;
 }
+
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_key.c openssl-1.0.0q/crypto/pkcs12/p12_key.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_key.c	2017-04-25 16:23:40.584621227 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 #include <openssl/bn.h>
 
@@ -135,14 +138,14 @@
 	u = EVP_MD_size (md_type);
 	if (u < 0)
 	    return 0;
-	D = OPENSSL_malloc (v);
-	Ai = OPENSSL_malloc (u);
-	B = OPENSSL_malloc (v + 1);
+	D  = (unsigned char *) OPENSSL_malloc (v);
+	Ai = (unsigned char *) OPENSSL_malloc (u);
+	B  = (unsigned char *) OPENSSL_malloc (v + 1);
 	Slen = v * ((saltlen+v-1)/v);
 	if(passlen) Plen = v * ((passlen+v-1)/v);
 	else Plen = 0;
 	Ilen = Slen + Plen;
-	I = OPENSSL_malloc (Ilen);
+	I = (unsigned char *) OPENSSL_malloc (Ilen);
 	Ij = BN_new();
 	Bpl1 = BN_new();
 	if (!D || !Ai || !B || !I || !Ij || !Bpl1)
@@ -161,7 +164,7 @@
 			EVP_DigestUpdate(&ctx, Ai, u);
 			EVP_DigestFinal_ex(&ctx, Ai, NULL);
 		}
-		memcpy (out, Ai, min (n, u));
+		op_memcpy (out, Ai, min (n, u));
 		if (u >= n) {
 #ifdef DEBUG_KEYGEN
 			fprintf(stderr, "Output KEY (length %d)\n", tmpn);
@@ -184,11 +187,11 @@
 			/* If more than 2^(v*8) - 1 cut off MSB */
 			if (Ijlen > v) {
 				BN_bn2bin (Ij, B);
-				memcpy (I + j, B + 1, v);
+				op_memcpy (I + j, B + 1, v);
 #ifndef PKCS12_BROKEN_KEYGEN
 			/* If less than v bytes pad with zeroes */
 			} else if (Ijlen < v) {
-				memset(I + j, 0, v - Ijlen);
+				op_memset(I + j, 0, v - Ijlen);
 				BN_bn2bin(Ij, I + j + v - Ijlen); 
 #endif
 			} else BN_bn2bin (Ij, I + j);
@@ -215,3 +218,5 @@
 	fprintf(stderr, "\n");	
 }
 #endif
+
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/pkcs12/p12_kiss.c openssl-1.0.0q/crypto/pkcs12/p12_kiss.c
--- openssl-1.0.0q.orig/crypto/pkcs12/p12_kiss.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/pkcs12/p12_kiss.c	2017-04-25 16:23:40.585620795 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/pkcs12.h>
 
 /* Simplified PKCS#12 routines */
@@ -163,9 +166,15 @@
  err:
 
 	if (pkey && *pkey)
+	{
 		EVP_PKEY_free(*pkey);
+                *pkey = NULL;
+        }
 	if (cert && *cert)
+	{
 		X509_free(*cert);
+		*cert = NULL;
+        }
 	if (x)
 		X509_free(x);
 	if (ocerts)
@@ -300,3 +309,4 @@
 	return 1;
 }
 
+#endif // LIBOPEAY_PKCS12_SUPPORT
